MARTe2-core - User story #1177

Improve thread priority implementation
22.06.2022 08:29 - Giuseppe Ferro

Status: Closed Start date: 22.06.2022
Priority: Normal Due date:
Assignee: % Done: 0%
Category: Estimated time: 0.00 hour
Target version: Spent time: 0.00 hour
Git branch (link): SVN commit

(link/?p=rev):
Git merge to develop
(link):
Description

--- Source/Core/Scheduler/L1Portability/Environment/Linux/Threads.cpp  2022-02-02 09:30:34.000000000 0000
++ Source/Core/Scheduler/L1Portability/Environment/Linux/Threads.cpp  2022-04-22 13:04:23.235370771 0000

@-161,8 +161.8 @
policy = SCHED_FIFO;//Only put FIFO (more aggressive) for the RealTimePriorityClass

break;
}
- uint32 priorityl evelToAssign = 28u * priorityClassNumber;

- priorityl evelToAssign += (static_cast<uint32>(prioLevel));

uint32 priorityLevelToAssign = 25u * priorityClassNumber;

+ priorityLevelToAssign += ((static_cast<uint32>(prioLevel)/15u)*24u);

sched_param param;
int32 ignore = 0;

- Better mapping between (PriorityClass, PriorityLevel)-->[0, 99]

- Replace polling+sleeptime with event semafore in the CircularBufferThreadInputDataSource::Synchronise method

History

#1 - 22.06.2022 08:30 - Giuseppe Ferro

- Status changed from New to Code: Impl

#2 - 22.06.2022 12:11 - Giuseppe Ferro

Giuseppe Ferro wrote:

--- Source/Core/Scheduler/L1Portability/Environment/Linux/Threads.cpp  2022-02-02 09:30:34.000000000 0000
++ Source/Core/Scheduler/L1Portability/Environment/Linux/Threads.cpp  2022-04-22 13:04:23.235370771 0000

@-161,8 +161.8 @

policy = SCHED_FIFO;//Only put FIFO (more aggressive) for the RealTimePriorityClass
break;

}

- uint32 priorityLevelToAssign = 28u * priorityClassNumber;

- priorityl evelToAssign += (static_cast<uint32>(prioLevel));

uint32 priorityLevelToAssign = 25u * priorityClassNumber;

+ priorityLevel ToAssign += ((static_cast<uint32>(prioLevel)*24u)/15u);

sched_param param;
int32 ignore = 0;

- Better mapping between (PriorityClass, PriorityLevel)-->[0, 99]

- Replace polling+sleeptime with event semafore in the CircularBufferThreadlnputDataSource::Synchronise method

#3 - 22.06.2022 13:24 - Giuseppe Ferro

branch '#1177_thread_priority'
added few CircularBufferThreadlnputDataSource tests for coverage

05.04.2025
#4 - 22.06.2022 13:24 - Giuseppe Ferro
- Status changed from Code: Impl to Unit: Rev

#5 - 22.06.2022 13:24 - Giuseppe Ferro

- Assignee changed from Giuseppe Ferro to André Neto

#6 - 30.06.2022 13:45 - André Neto
- Assignee deleted (André Neto)
- Status changed from Unit: Rev to Closed

Merged at b191ac7{8a1840d15ff91c8b65d0049219040748

05.04.2025
